\chapterpic{\resizebox{\textwidth}{!}{\includegraphics{pics/starwars.eps}}}%
           {C3PO and R2D2 from the movie series Star Wars. Many
             such robot types are the reason why many people have
             some slight fear against robots today even though
             these two was rather harmless.  }
           
\chapter{Modular robotics}

As the occupants of the modern world have learned to live in a highly
computerized society, we have accepted the fact that computers are
getting more and more common in our daily lives. In this society we
are though still very unfamiliar with robots, which means that we have
some very imaginative ideas about what a robot is.

If you ask any person in the street what he or she believes a
``robot'' is, he or she will most likely tell you colorful stories
about androids. There will be stories about \emph{C3PO} and
\emph{R2D2} from the movie series \emph{Star wars} or more modern: a
robot like the \emph{I-ROBOT} from the movie by the same name.

Robots are often associated with many myths which are created by the
medias. These gives people the impression that robots will be able to
do everything which we as humans can do, just better. Eventually the
robots will battle against the humans and take over the world as
visualized in the movies
\emph{Terminator} or \emph{Matrix}.

Sadly I cannot argument that this is a thing which will newer happen,
but I can say that it is rather certain that this is a thing which is
not likely to happen during the next couple of days.

I leave the argumentation of these rather sensitive areas to the
philosophers. Instead I will take a leap into an area of robotics as I
know it today.

% A robot is often a very simple (at least compared to a human) one
% armed robots These are robots which are able to perform repetitive
% tasks very well, but at the same time not able to adapt very well to
% changes in the environment. Therefore a huge effort is being made
% building robots that are more self aware and therefore able to adapt
% to some degree of changes.

%% \subsection{The classic robot}

%% \begin{Figure}[H]
%% \begin{pspicture}(\linewidth,6)
%% \rput[lb](0,1.2){\epsfig{file=pics/abb-robot,width=3.5cm}}
%% \rput[lb](4,0.5){\epsfig{file=pics/kuka-robot,width=3.5cm}}
%% \rput[lb](8,1.5){\epsfig{file=pics/easybot,width=4cm}}
%% \rput[cb](1.75,0.2){(a)}
%% \rput[cb](5.75,0.2){(b)}
%% \rput[cb](10,0.2){(c)}
%% \end{pspicture}
%% \caption[Three different classic type robots]{Three different classic
%% types of robots (a) ABB robot, (b) KUKA robot and (c) Easybot robot}
%% \end{Figure}

%% Modular robots today have had around 20 years of development and is
%% continuously evolving and soon be mature enough where it will be able
%% to move in to the industry. But the usage of modular robots is still
%% limited to academic environments, but the modular philosophy is slowly
%% starting to emerge in production aiding in building cheaper robot
%% types. (see figure
%% \vref{fig:heterogeneous_robots})

%% The \emph{easybot} robot from Universal Robots, is a typical robot
%% that is inspired by the idea of modular robotics. Here each joint is
%% one of two different module types that is easy replaceable in the case
%% of failure. This is of course only a single idea lent from the modular
%% world, but it is a start.


\section{The modular robot}
During the last ten or fifteen years a new kind of intuitive robotics
has emerged. This kind of robotics is based around modular building
blocks which resemble the kind of bricks that many people can recall
playing with during their childhood. The modules people used, started
out as being simple bricks but later some evolved in to playing with
more sophisticated building blocks like the well known and patented
LEGO brick. The main idea about these bricks is that they can be
assembled in to one form which will resemble a simple shape like for
instance a car, next you can separate the bricks and reassemble them
into a new shape which forms a different shape like a house or a
plane.

The individual bricks are just what they are - bricks. But these
bricks can be used to create any representation in principle limited
only by imagination and maybe also any task necessary.

\begin{sidefig}
\epsfig{file=ink/maintainance,width=4cm}
\caption{A first idea of an application for a modular
robot. Originally proposed by Fukuda \cite{fukuda}}\label{fig:fukuda}
\end{sidefig}
The idea of a modular robot was originally proposed by Fukuda
\cite{fukuda} in 1988. He stated that the classical robots
based of mainly four to six axis, is designed for fixed total
solutions that does not have the versatility to adapt to a changing
work environment and demands. He proposed a series of different
applications that would be suitable for the modular robot but
difficult of not impossible for a classical robot. One application was
the ability to easily decompose a modular robotic system and store it
in a spacecraft for later reassembly. Another example application is a
closed tank with a small entrance where you feed small modules in to
the tank entrance (see figure \ref{fig:fukuda}) I will highly advice
on reading his article as it forms the basis for modular robots of
today.

His proposal spawned many new projects that was either what we know as
modular \emph{reconfigurable robots} or \emph{self-reconfigurable
robots}. These projects have investigated the modular paradigm
focusing mainly on how do we make the module that can actually execute
the task that was necessary to make a modular robot able to do these
applications. This was both a physical challenge as well as a control
challenge since questions like how do we make modules able to move
from a to b in the structure, how do we make the modular robot
actually move as a union of modules, how do we make a module that is
able to actually fulfill a robot in three dimensions (see
\cite[chapter 2]{kaspers})

\subsubsection{Design principles}
During this period, a lot of principles and concepts have been
unveiled based on the way one thing of a modular robot. A modular
robot has a lot of resemblance with biological objects as it is
typical for the field of artificial intelligence. Each module
resembles the identity of a single cell that is only able to execute a
very limited amount of functionality. But even within the range of a
few cells/modules it is possible to achieve quite complex
tasks. But by increasing the complexity of the robot, there is also a
tendency to an increasing complexity in the control of the
robot. Therefore it is feasible to divide it in to separate group
sizes. 

%% \subsection{Pack, herd or swarm size robots}
%% A modular robot is built from a bulk of identical modules that when
%% connected form a whole robot. But the amount of modules used for the
%% robot has an important influence on how it can be controlled and
%% built. Therefore there exists three different sizes of modular robots:
%% \emph{pack}, \emph{herd} and \emph{swarm} size.

\paragraph{Pack}
A pack is usually a robot consisting of tens of modules. In such a
configuration each module carry a dedicated function in the robot,
meaning that failure in a single module will most likely cause the
entire robot to fail since it is very dependent on each module. The
control level in the pack size modular robot is high and relatively
simple due to the low amount of modules.

\paragraph{Herd}
A herd scales by a factor of ten compared to a pack robot, meaning
that a Herd consists of hundreds of modules. Here it is unlikely that
the module will be able to perform a task that isolated would have a
high impact on the robots activity. Instead several modules team up
and creates functional units. Such grouping allows control of the
functionality from a high level view, but of course the complexity in
the communication also grows.

\paragraph{Swarm}
A swarm robot consists of thousands (myriads) of modules or more. The
best possible analogy to this is an ant colony where a colony
typically consist of extremely large amounts of ants.  The individual
ants has no function (except the drone queen) and as such are useless
to perform any kind of major functionality that add value to the
swarm. But when they unite in small subunits at the size of packs or
herds, they are able to accomplish valuable tasks. The individual
modules acts on an autonomously bases and as such are not important to
the structure of the robot. To elaborate on that it means that the
modules are not directly control able and therefore is controlled by
behaviors. To further elaborate on that it may mean that modules may
learn behaviours that is not planned from the beginning, but may
\emph{grow} to learn new behaviors.

These definitions may have influence on many levels of the design of
the modules, but are particularly interesting when choosing a
communication method for a robot. A scheme that will work well for
controlling a small pack of modules may scale bad when applied to a
herd or even a swarm based approach. As to the opposite, choosing a
mechanism that works well for a swarm based approach, may be
impractical or simply to slow for a pack based approach.



%% So why is it that these robots are so interesting to investigate? The
%% classical robots that is used in the industry, are all very capable to
%% solve their tasks and even to an extreme level of precision that is
%% unsurpassed by humans. Of course this is a question that can be
%% debated a lot, but it may be the same question as to ask what is
%% better, the wheel or the leg? Well the wheel is much faster than the
%% leg as long as it has a good surface to work on, but if the surface
%% gets rough and unpredictable, a wheel gets in to problems while the
%% leg simply adapts to the situation. This analogy is important since it
%% shows one of the most fundamental arguments for why the modular robot
%% is so interesting: the ability to modify itself / be modified to the
%% task at hand. Another argument that is important is the ability to
%% mass produce a high amount of identical, simple and cheap
%% modules. This gives the option of creating a cheap robot that will be
%% a lot cheaper than the classical heterogeneous robot.



%As many people have seen how the idea of modular robotics can handle
%many diverse tasks, a lot of different projects have emerged which are
%based on the modular idea, but with individually different approaches.

%\begin{sidefig}
%\begin{pspicture}(4,4)
%\epsfig{file=pics/attron,width=4.2cm}
%\end{pspicture}
%\caption[The Atron module]{The Atron module is a self
%  reconfigurable robot. Its method of self reconfiguration is by
%  moving around on the other modules with its specially designed
%  grippers.}\label{fig:atron}
% \end{sidefig}
% Here at the \emph{Maersk Mc-Kinney M\o ller Institute} at
% \emph{University of Southern Denmark}, we are currently focusing
% on two such modular robots. This is the \emph{Atron} (see figure
% \ref{fig:atron}) and \emph{Odin} robot.

% I will not spend any space here on describing the \emph{Atron}
% module, but only direct to web pages like the hydra
% project\footnote{See http://www.hydra-robot.com}.

% \todo{Try to go a little more into details about what the definitions
% for the modular robots and maybe even bring in a lot of related works} 


\section {Communication in its major forms}
The communication in a modular robot is a rather subtle topic since it
is quickly evident that some type of communication must be used for
all these individual modules to work together.

There exists basically two major communication forms, a global
communication and a local communication scheme. But among these there
exists also some communication forms that either builds on top or
utilize them to create a sort of hybrid between these two basic
approaches. First, let us define the two basic communication forms:

\paragraph {Global communication}  
A scheme where everyone is connected to the same physical
communication media which means that all participants needs to
participate in a battle for communication. This approach is
intuitively easy to understand but practically it often leads a series
of problems as a physical wire needs to be connected to all the
modules at all times. As such it is very use full if the robot is to
be used with centralized control or simply under development where it
is easy to downloading new code and testing. Some later experiments
has though started to utilize wireless medias such as the ZigBee,
Bluetooth and other Wi Fi media protocols.

\paragraph{Local communication}
Local means that the modules only have communication with their
directly attached neighbours. This often yields a lot of benefits
since first of all its very likely that the modules needs to perform
close synchronization with their neighbors. But another thing is the
ability of the design of the communication hardware such that it
provides information about the local physical configuration (eg. how
is my neighbor orientated compared to me) The drawback is of course
that communication with other modules may be impossible or impractical
since the data needs to be switched through a large amount of modules.

\paragraph{Implicit communication}
An extra class of communication not mentioned earlier is the
\emph{implicit communication form}. Implicit communication is known
from the nature where instead of performing communication in its
direct form with sound and commands, a creature may choose to
communicate through observations of actions of another fellow
creature. This field is of great interest and a major topic in
artificial intelligence, but it will not be covered here as I only
focus on communication in its direct form. But this kind of 
communication is though more thoroughly described by 
\cite[chapter 7]{aima}.

In between the two major communication forms described, there of
course also exists different hybrids. A classical hybrid is seen in
the local communication scheme where the allowed communication
normally only is allowed between directly attached neighbours. This
communication can be extended to a more global alike scheme by using
forwarding of packages. This of course is not a timely efficient
method of communication since the time to transfer a message from one
module to another is highly dependant on the amount of modules in
between. However a large class of control schemes can utilize this
specific behaviour and creative quite complex control system with this
approach. A hormone based control method, as described by
\cite{hormone_control}, is a very good example of that.

Another communication approach, that is one of the key features in the
ODIN module, is to implement a hardware functionality for linking a
communication wire through the module \emph{on demand}. When I write
\emph{on demand}, I refer to a feature where the module is able to
internally tie the two communication terminals together as one by
closing a digital switch. (See \cite{hybrid_communication}) When such
communication channels are created in multiple linked modules, it
allows more distant modules to communicate as if they were directly
attached neighbours. This means that functional units like legs are
allowed to have a very tight synchronization between each other, but
only if needed. Units that doesn't have the possibility to tie the
communication terminals together, can still benefit somewhat from this
approach by using an communication algorithm that allows directed
messages (see section \ref{sec:forwarding_without_tie}).

\subsection{Communication approaches}
\begin{itemize}
\item Ordinary routed communication
\item Configuration based communication
\item Homone and gradient based communication
\end{itemize}

\subsection{The subtleties in modular communication}
\label{sec:subtleties_in_modular_comm} 
\paragraph{Physical Configuration}
As mentioned in section \ref{sec:def_diff_com_forms}, it is possible
to achieve some \emph{extra} information as a consequence of knowing
how the physical layout of the communication is made. For the ATRON
modules it is possible to tell the orientation of a module compared to
the orientation of the message originator. This is done by adding the
orientation of each communication link the message pass through,
together. In the ATRON module, this is a fairly easy task as there is
only a few possible orientations.

\paragraph{Identity problem}
When a module is being developed for pack and herd size robots, it is
quite common to provide a unique identity to each module and thereby
easing the development of the controller. But for swarm size robots,
this is not a plausible approach since to program the amount of unique
modules is simply an impossible task. Therefore all modules are often
given the same code base and thereby no unique identity. Since this
problem seems to be general in the modular robotics fields, I will
from now name it the ``identity problem''

There is no unique way to solve this problem, but its not the same as
to say there is no solutions. But the solutions is often very tightly
linked with the control approach chosen for the modules, which means
that it is impossible to say from a generic point of view, what the
identity will be.

One approach is using a special class of hormone based
control\footnote{Autonomous Decentralized Systems (ADS)}
methods. Hormones in general are based on the idea that some event in
environment triggers the release of hormones to the nearest neighbors
in the topology. The hormones travels out in circles around the point
of origin and influences the behavior for the modules that receives
the hormones. (The paradigm of hormones as a control method is
described further in section \vref{sec:hormone_control}).  A side
effect of using hormones, is the possibility to say that modules,
affected by an outside hormone, obtains a special identity based on
their current behavior. Given this approach, we can still use the idea
of identity in a identity less system. This gives the possibility of
routing messages between identified modules instead of just
broadcasting to all modules.

\paragraph{Robustness}
Another thing that is very important when defining communication in
modular robotics, is \emph{robustness} \todo{Add some knowledge
  references}. Robustness in the communication domain is the ability
to survive changes in the topology or maybe congestion due to high
traffic. Some of the sources for changes in the topology may be simple
reconfiguration of robot, which means that the robot may be divided in
to several sub parts that have to be able to have continues
communication.


\section {Algorithms and methids known from other areas}
I have in section \vref{sec:def_diff_com_forms}, shown the major
classes of communication together with some of the hybrids. Though
these sounds very specific to this field of computation, there is a
large class of algorithmic approaches from other areas of networking
that has some use full analogies.

Some of the most used approaches are the methods that we normally see
applied in the Internet. Here a large amount of routers are spread all
over the surface of the earth (and some even in satellites)
controlling the forwarding of messages from one place to another. Each
time a message is being routed through the large mesh of grid points,
it is following a carefully evolved path that is dynamically being
controlled by the individual routers. The controllers constantly
evaluates the network to allow packages to be send as quickly as
possible through the net. But though the net is quite fixed in
structure, the routing in the net is a quite dynamic feature. As the
net is suffering from congestion, satellites that are moving out of
reach and laptops are moving from one major WLAN to another, the
routers finds constantly the optimal route for the current net
configuration.

Perhaps the currently most widely used algorithm for finding optimal
routes today is the \emph{Dijkstra} algorithm \cite{dijkstra} conceived by
Dutch computer scientist Edsger Dijkstra in 1959. This algorithm is a
search algorithm that finds the ``single-source shortest path''
between two points. Originally the algorithm was designed to be
executed in a sequential form, but since the algorithm has gained high
popularity in the routing domain, a series of different parallel
implementations of the algorithms have been developed.

\begin{itemize}
\item Describe the used DV and RV algorithms
\end{itemize}

It seems that it is a good idea to study the ideas from routing in the
Internet. ``Borrowing'' from this well tested area can easily be a
huge time saver instead of reinventing the wheels. But care must be
taken, since as I have mentioned in section
\vref{sec:subtleties_in_modular_comm}, there exists some constraints
(identity problem) that has to be sorted out prior to using the
routing approaches.

\hspace{0.1\linewidth}\parbox{0.8\linewidth}{
\color{red} One of the things also important here is how the cellular
structure is possible in the bluetooth network. This can be utilized
when applying a cell of 256 modules that needs to use repeaters for
sending data for bigger structures.}


\section {Reflections on these algorithms/methods}

\begin{Figure}[H]
\begin{pspicture}(\linewidth,11)
\psframe*(\linewidth,11){}
\rput[cm](3.3,3.1){\epsfig{file=pics/superbot,width=6cm}}
\rput[cm](9.1,3.1){\epsfig{file=pics/Polybot,width=5cm}}
\rput[cm](9.1,8.1){\epsfig{file=pics/mtranmodule,width=5cm}}
\end{pspicture}
\caption{Write something here..}
\end{Figure}

% ------------------------------







\section{The Odin module}
% structural design for the module
% reconfigurable interface between the modules.
% basic communication including the option for forwarding between terminals.
% more high level communication 
% proposed abstract approaches (layered perspective)
The \emph{Odin} robot is a lattice based structure consisting of
several basic module types like actuation-, sensory-, power- and
simple structural modules. The link module connects to a node module
which has the option to connect 12 links in total. In this structure,
it is the edges between the nodes, that contain the computational
power while the nodes are just pure connection structure modules.

In terms of modular robotics, it is dynamically reconfigurable since
it support moving links from one location in the structure to another,
while the robot is actively executing a task. But it is not self
reconfigurable since it is not able to on its own effort to alter the
configuration. This is how \emph{Atron} works, since it is are able to
move its modules around in the structure and thereby alter its
configuration.

The modules do not individually support power internally but instead a
special power module is inserted into one or more places in the graph
structure. Therefore the node between the links also support transfer
of power between the modules.

It is possible for the modules to perform local communication to the
neighboring modules that are connected to the directly attached
node. But besides local communication, the modules also supports
directly forwarding data inside, so a more sophisticated communication
structure can be achieved as described in section
\vref{sec:global_and_hybrid_communication}.

The communication scheme for modular robots like this, is quite
interesting since these kind of robots most often will have some
weaknesses compared to normal robots solely because of their modular
structure.

These weaknesses are:

\begin{itemize}
\item A first thing which has to be taken care of is the
  possibility of reconfiguration. This means that a connection may
  never be considered stable since there is a big chance a module may
  suddenly be removed. Therefore it has to find an alternative route
  before it can reach its goal.

\item Next a direct connection from one module is very unlikely
  to exist, except in the situation which the modules are directly
  neighbors to each other. Therefore a method for sending messages
  across several different modules is needed.

\item From a artificial intelligence perspective a module is in
  principle just an entity without identity. As the module is inserted
  in the structure it may learn a unique behavior - but that is only
  as long as the module is located at this position. So once the
  module is removed and inserted in to a new position, it exists
  without identity (a behavior can in principle equal an identity).
\end{itemize}

The first version of the \emph{Odin} link module contains a special
communication feature which has not been described yet. It supports a
forwarding mechanism which allows two node modules to become
electrically connected, forming a bigger node with 24 termination
points. This is achieved by internally connecting the terminals in the
module allowing forwarding messages directly and without any
delay. Richardo Franco Mendoza Garcia describes the hardware
implementation in his article
\cite{hybrid_communication}.

\section{Global and Hybrid communication}
\label{sec:global_and_hybrid_communication}
The argumentation for why we should use global or hybrid communication
is difficult to give full coverage since it is very application
specific. But a few applications can be mentioned where the
communication schemes will be useful.

A couple of applications that would require global communication are
for instance when we want to share a piece of information to all
available modules (like an update of code to all modules) or if we
need to synchronize the time for all modules.

Another application that would require the hybrid communication
scheme, could for instance be a two legged robot that would require
close communication between the leg modules in order to reach proper
locomotion.

One option that is possible with the inter connection functionality is
to create a global communication network where all the links are
connected to the same physical net. This is for instance useful if we
want to make an update to all the modules at the same time or if we
want to synchronize the modules. But creating global communication in
a connected graph like this, will be very likely to create loops. This
kind of communication loop is not desirable since they may at a high
level cause message storms, but also at a lower level alter the
electrical impedance and thereby reduce the message transfer
distance. (see \cite{hybrid_communication})

If we imagine that there exist two modules in the structure where the
communication between these two modules tend to be high, it would be
desirable to have a good communication between these. Therefore the
link modules that exists between these two collaborating modules, may
decide to connect the two modules together allowing them to
communicate directly to each other. But there certainly also exists a
problem in this scheme since now all other kinds of communication that
is likely to pass perpendicular across this now physical line, must
either choose to accept crossing this net and therefore also accept
the amount of extra information that flows in this net; or choose to
form a new directly connected network that may go around the first
network. This is of course effective, but in terms of speed, very
space ineffective.

\subsection{Time slotting}
An alternative approach to this scenario is to implement time slotting
on the links. This means that the modules will let their channels be
open at specific time slots allowing messages to flow freely through
the net during this time slot. Outside this time period, normal
transmissions is carried out, or another net is activated which
connects different parts of the net. This scheme is very similar to
the technique carried out in older relay controlled phone centrals
that only had a limited amount of channels to communicate on.

\subsection{Next version of the Odin module}
The next version of the \emph{Odin} robot does not including the
forwarding scheme in its direct form. For this reason we now make the
looping through the microprocessor. Ergo: the electrical forwarding
channel is now removed.

This modification has quite an influence on the communication since
the risk of creating electrical loops has diminished. The limit (as
mentioned in~\cite{hybrid_communication}) on the amount of links that
could be included in one net, is now gone. This is due to the fact
that each link module that receives a message at one of its terminal
ends, enhances the signal as it forwards it to the other terminal end.

Since the communication does not include the internal connection
scheme anymore, I will not focus any further on the time slotting
method mentioned in the previous section.

\emph{But the possibilities with such a network is important and
  kept in mind should we decide to re implement the forwarding channel
  in the link modules.}
